# ncurses 6.1 - patch 20181201 - Thomas E. Dickey
#
# ------------------------------------------------------------------------------
#
# Ncurses 6.1 is at
# 	ftp.gnu.org:/pub/gnu
#
# Patches for ncurses 6.1 can be found at
# 	ftp://ftp.invisible-island.net/ncurses/6.1
#	http://invisible-mirror.net/archives/ncurses/6.1 
#
# ------------------------------------------------------------------------------
# ftp://ftp.invisible-island.net/ncurses/6.1/ncurses-6.1-20181201.patch.gz
# patch by Thomas E. Dickey <dickey@invisible-island.net>
# created  Sun Dec  2 01:14:13 UTC 2018
# ------------------------------------------------------------------------------
# Ada95/aclocal.m4                 |    8 ++++----
# Ada95/configure                  |    2 +-
# NEWS                             |    9 ++++++++-
# VERSION                          |    2 +-
# aclocal.m4                       |    8 ++++----
# config.guess                     |    5 ++++-
# config.sub                       |    5 +++--
# configure                        |    2 +-
# dist.mk                          |    4 ++--
# ncurses/curses.priv.h            |    3 ++-
# package/debian-mingw/changelog   |    4 ++--
# package/debian-mingw64/changelog |    4 ++--
# package/debian/changelog         |    4 ++--
# package/mingw-ncurses.nsi        |    4 ++--
# package/mingw-ncurses.spec       |    2 +-
# package/ncurses.spec             |    2 +-
# package/ncursest.spec            |    2 +-
# test/aclocal.m4                  |    6 +++---
# test/configure                   |    2 +-
# test/ncurses.c                   |   37 ++++++++++++++++++++++++++++++++++---
# 20 files changed, 79 insertions(+), 36 deletions(-)
# ------------------------------------------------------------------------------
Index: Ada95/aclocal.m4
Prereq:  1.139 
--- ncurses-6.1-20181125+/Ada95/aclocal.m4	2018-11-11 00:48:11.000000000 +0000
+++ ncurses-6.1-20181201/Ada95/aclocal.m4	2018-12-01 21:07:22.000000000 +0000
@@ -28,7 +28,7 @@
 dnl
 dnl Author: Thomas E. Dickey
 dnl
-dnl $Id: aclocal.m4,v 1.139 2018/11/11 00:48:11 tom Exp $
+dnl $Id: aclocal.m4,v 1.140 2018/12/01 21:07:22 tom Exp $
 dnl Macros used in NCURSES Ada95 auto-configuration script.
 dnl
 dnl These macros are maintained separately from NCURSES.  The copyright on
@@ -3051,7 +3051,7 @@
 test -n "$PROG_EXT" && AC_DEFINE_UNQUOTED(PROG_EXT,"$PROG_EXT",[Define to the program extension (normally blank)])
 ])dnl
 dnl ---------------------------------------------------------------------------
-dnl CF_PROG_GNAT version: 7 updated: 2018/11/10 18:37:39
+dnl CF_PROG_GNAT version: 8 updated: 2018/11/10 19:47:04
 dnl ------------
 dnl Check for gnatmake, ensure that it is complete.
 AC_DEFUN([CF_PROG_GNAT],[
@@ -4154,7 +4154,7 @@
 ])
 ])dnl
 dnl ---------------------------------------------------------------------------
-dnl CF_XOPEN_SOURCE version: 53 updated: 2018/06/16 18:58:58
+dnl CF_XOPEN_SOURCE version: 54 updated: 2018/11/07 07:43:44
 dnl ---------------
 dnl Try to get _XOPEN_SOURCE defined properly that we can use POSIX functions,
 dnl or adapt to the vendor's definitions to get equivalent functionality,
@@ -4184,7 +4184,7 @@
 	cf_xopen_source="-D_DARWIN_C_SOURCE"
 	cf_XOPEN_SOURCE=
 	;;
-(freebsd*|dragonfly*)
+(freebsd*|dragonfly*|midnightbsd*)
 	# 5.x headers associate
 	#	_XOPEN_SOURCE=600 with _POSIX_C_SOURCE=200112L
 	#	_XOPEN_SOURCE=500 with _POSIX_C_SOURCE=199506L
Index: Ada95/configure
--- ncurses-6.1-20181125+/Ada95/configure	2018-11-11 00:48:33.000000000 +0000
+++ ncurses-6.1-20181201/Ada95/configure	2018-12-01 21:07:49.000000000 +0000
@@ -10940,7 +10940,7 @@
 	cf_xopen_source="-D_DARWIN_C_SOURCE"
 	cf_XOPEN_SOURCE=
 	;;
-(freebsd*|dragonfly*)
+(freebsd*|dragonfly*|midnightbsd*)
 	# 5.x headers associate
 	#	_XOPEN_SOURCE=600 with _POSIX_C_SOURCE=200112L
 	#	_XOPEN_SOURCE=500 with _POSIX_C_SOURCE=199506L
Index: NEWS
Prereq:  1.3222 
--- ncurses-6.1-20181125+/NEWS	2018-11-25 11:29:51.000000000 +0000
+++ ncurses-6.1-20181201/NEWS	2018-12-01 20:59:08.000000000 +0000
@@ -25,7 +25,7 @@
 -- sale, use or other dealings in this Software without prior written        --
 -- authorization.                                                            --
 -------------------------------------------------------------------------------
--- $Id: NEWS,v 1.3222 2018/11/25 11:29:51 tom Exp $
+-- $Id: NEWS,v 1.3225 2018/12/01 20:59:08 tom Exp $
 -------------------------------------------------------------------------------
 
 This is a log of changes that ncurses has gone through since Zeyd started
@@ -45,6 +45,13 @@
 Changes through 1.9.9e did not credit all contributions;
 it is not possible to add this information.
 
+20181201
+	+ add midnightbsd to CF_XOPEN_SOURCE macro (patch by Urs Jansen).
+	+ add "@" command to test/ncurses F-test, to allow rapid jump to
+	  different character pages.
+	+ update config.guess, config.sub from
+		http://git.savannah.gnu.org/cgit/config.git
+
 20181125
 	+ build-fix (reports by Chih-Hsuan Yen, Sven Joachim).
 
Index: VERSION
--- ncurses-6.1-20181125+/VERSION	2018-11-25 11:25:14.000000000 +0000
+++ ncurses-6.1-20181201/VERSION	2018-11-30 23:49:03.000000000 +0000
@@ -1 +1 @@
-5:0:10	6.1	20181125
+5:0:10	6.1	20181201
Index: aclocal.m4
Prereq:  1.857 
--- ncurses-6.1-20181125+/aclocal.m4	2018-11-11 00:47:04.000000000 +0000
+++ ncurses-6.1-20181201/aclocal.m4	2018-12-01 21:00:13.000000000 +0000
@@ -28,7 +28,7 @@
 dnl
 dnl Author: Thomas E. Dickey 1995-on
 dnl
-dnl $Id: aclocal.m4,v 1.857 2018/11/11 00:47:04 tom Exp $
+dnl $Id: aclocal.m4,v 1.858 2018/12/01 21:00:13 tom Exp $
 dnl Macros used in NCURSES auto-configuration script.
 dnl
 dnl These macros are maintained separately from NCURSES.  The copyright on
@@ -5643,7 +5643,7 @@
 	test -z "$EGREP" && AC_MSG_ERROR(No egrep program found)
 ])dnl
 dnl ---------------------------------------------------------------------------
-dnl CF_PROG_GNAT version: 7 updated: 2018/11/10 18:37:39
+dnl CF_PROG_GNAT version: 8 updated: 2018/11/10 19:47:04
 dnl ------------
 dnl Check for gnatmake, ensure that it is complete.
 AC_DEFUN([CF_PROG_GNAT],[
@@ -8326,7 +8326,7 @@
 AC_SUBST(no_x11_rgb)
 ])dnl
 dnl ---------------------------------------------------------------------------
-dnl CF_XOPEN_SOURCE version: 53 updated: 2018/06/16 18:58:58
+dnl CF_XOPEN_SOURCE version: 54 updated: 2018/11/07 07:43:44
 dnl ---------------
 dnl Try to get _XOPEN_SOURCE defined properly that we can use POSIX functions,
 dnl or adapt to the vendor's definitions to get equivalent functionality,
@@ -8356,7 +8356,7 @@
 	cf_xopen_source="-D_DARWIN_C_SOURCE"
 	cf_XOPEN_SOURCE=
 	;;
-(freebsd*|dragonfly*)
+(freebsd*|dragonfly*|midnightbsd*)
 	# 5.x headers associate
 	#	_XOPEN_SOURCE=600 with _POSIX_C_SOURCE=200112L
 	#	_XOPEN_SOURCE=500 with _POSIX_C_SOURCE=199506L
Index: config.guess
--- ncurses-6.1-20181125+/config.guess	2018-08-29 20:40:16.000000000 +0000
+++ ncurses-6.1-20181201/config.guess	2018-12-01 18:54:19.000000000 +0000
@@ -2,7 +2,7 @@
 # Attempt to guess a canonical system name.
 #   Copyright 1992-2018 Free Software Foundation, Inc.
 
-timestamp='2018-08-29'
+timestamp='2018-11-28'
 
 # This file is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by
@@ -1424,6 +1424,9 @@
     amd64:Isilon\ OneFS:*:*)
 	echo x86_64-unknown-onefs
 	exit ;;
+    *:Unleashed:*:*)
+	echo "$UNAME_MACHINE"-unknown-unleashed"$UNAME_RELEASE"
+	exit ;;
 esac
 
 echo "$0: unable to guess system type" >&2
Index: config.sub
--- ncurses-6.1-20181125+/config.sub	2018-08-29 20:40:16.000000000 +0000
+++ ncurses-6.1-20181201/config.sub	2018-12-01 18:54:19.000000000 +0000
@@ -2,7 +2,7 @@
 # Configuration validation subroutine script.
 #   Copyright 1992-2018 Free Software Foundation, Inc.
 
-timestamp='2018-08-29'
+timestamp='2018-11-28'
 
 # This file is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by
@@ -1161,6 +1161,7 @@
 			| alpha64 | alpha64ev[4-8] | alpha64ev56 | alpha64ev6[78] \
 			| alphapca5[67] | alpha64pca5[67] \
 			| am33_2.0 \
+			| amdgcn \
 			| arc | arceb \
 			| arm  | arm[lb]e | arme[lb] | armv* \
 			| avr | avr32 \
@@ -1360,7 +1361,7 @@
 	     | powermax* | dnix* | nx6 | nx7 | sei* | dragonfly* \
 	     | skyos* | haiku* | rdos* | toppers* | drops* | es* \
 	     | onefs* | tirtos* | phoenix* | fuchsia* | redox* | bme* \
-	     | midnightbsd*)
+	     | midnightbsd* | amdhsa* | unleashed*)
 	# Remember, each alternative MUST END IN *, to match a version number.
 		;;
 	qnx*)
Index: configure
--- ncurses-6.1-20181125+/configure	2018-11-24 22:44:00.000000000 +0000
+++ ncurses-6.1-20181201/configure	2018-12-01 21:04:05.000000000 +0000
@@ -8780,7 +8780,7 @@
 	cf_xopen_source="-D_DARWIN_C_SOURCE"
 	cf_XOPEN_SOURCE=
 	;;
-(freebsd*|dragonfly*)
+(freebsd*|dragonfly*|midnightbsd*)
 	# 5.x headers associate
 	#	_XOPEN_SOURCE=600 with _POSIX_C_SOURCE=200112L
 	#	_XOPEN_SOURCE=500 with _POSIX_C_SOURCE=199506L
Index: dist.mk
Prereq:  1.1253 
--- ncurses-6.1-20181125+/dist.mk	2018-11-25 11:25:14.000000000 +0000
+++ ncurses-6.1-20181201/dist.mk	2018-11-30 23:49:03.000000000 +0000
@@ -25,7 +25,7 @@
 # use or other dealings in this Software without prior written               #
 # authorization.                                                             #
 ##############################################################################
-# $Id: dist.mk,v 1.1253 2018/11/25 11:25:14 tom Exp $
+# $Id: dist.mk,v 1.1254 2018/11/30 23:49:03 tom Exp $
 # Makefile for creating ncurses distributions.
 #
 # This only needs to be used directly as a makefile by developers, but
@@ -37,7 +37,7 @@
 # These define the major/minor/patch versions of ncurses.
 NCURSES_MAJOR = 6
 NCURSES_MINOR = 1
-NCURSES_PATCH = 20181125
+NCURSES_PATCH = 20181201
 
 # We don't append the patch to the version, since this only applies to releases
 VERSION = $(NCURSES_MAJOR).$(NCURSES_MINOR)
Index: ncurses/curses.priv.h
Prereq:  1.608 
--- ncurses-6.1-20181125+/ncurses/curses.priv.h	2018-11-25 11:26:03.000000000 +0000
+++ ncurses-6.1-20181201/ncurses/curses.priv.h	2018-12-01 22:04:24.000000000 +0000
@@ -34,7 +34,7 @@
  ****************************************************************************/
 
 /*
- * $Id: curses.priv.h,v 1.608 2018/11/25 11:26:03 tom Exp $
+ * $Id: curses.priv.h,v 1.609 2018/12/01 22:04:24 tom Exp $
  *
  *	curses.priv.h
  *
@@ -1623,6 +1623,7 @@
 #define isWidecExt(ch)	(0)
 #define if_WIDEC(code) /* nothing */
 
+#define Charable(ch)	((ch) >= ' ' && (ch) <= '~')
 #define L(ch)		ch
 #endif /* } */
 
Index: package/debian-mingw/changelog
--- ncurses-6.1-20181125+/package/debian-mingw/changelog	2018-11-25 11:25:14.000000000 +0000
+++ ncurses-6.1-20181201/package/debian-mingw/changelog	2018-11-30 23:49:03.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.1+20181125) unstable; urgency=low
+ncurses6 (6.1+20181201) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 25 Nov 2018 06:25:14 -0500
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Fri, 30 Nov 2018 18:49:03 -0500
 
 ncurses6 (5.9-20131005) unstable; urgency=low
 
Index: package/debian-mingw64/changelog
--- ncurses-6.1-20181125+/package/debian-mingw64/changelog	2018-11-25 11:25:14.000000000 +0000
+++ ncurses-6.1-20181201/package/debian-mingw64/changelog	2018-11-30 23:49:03.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.1+20181125) unstable; urgency=low
+ncurses6 (6.1+20181201) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 25 Nov 2018 06:25:14 -0500
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Fri, 30 Nov 2018 18:49:03 -0500
 
 ncurses6 (5.9-20131005) unstable; urgency=low
 
Index: package/debian/changelog
--- ncurses-6.1-20181125+/package/debian/changelog	2018-11-25 11:25:14.000000000 +0000
+++ ncurses-6.1-20181201/package/debian/changelog	2018-11-30 23:49:03.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.1+20181125) unstable; urgency=low
+ncurses6 (6.1+20181201) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 25 Nov 2018 06:25:14 -0500
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Fri, 30 Nov 2018 18:49:03 -0500
 
 ncurses6 (5.9-20120608) unstable; urgency=low
 
Index: package/mingw-ncurses.nsi
Prereq:  1.300 
--- ncurses-6.1-20181125+/package/mingw-ncurses.nsi	2018-11-25 11:25:14.000000000 +0000
+++ ncurses-6.1-20181201/package/mingw-ncurses.nsi	2018-11-30 23:49:03.000000000 +0000
@@ -1,4 +1,4 @@
-; $Id: mingw-ncurses.nsi,v 1.300 2018/11/25 11:25:14 tom Exp $
+; $Id: mingw-ncurses.nsi,v 1.301 2018/11/30 23:49:03 tom Exp $
 
 ; TODO add examples
 ; TODO bump ABI to 6
@@ -10,7 +10,7 @@
 !define VERSION_MAJOR "6"
 !define VERSION_MINOR "1"
 !define VERSION_YYYY  "2018"
-!define VERSION_MMDD  "1125"
+!define VERSION_MMDD  "1201"
 !define VERSION_PATCH ${VERSION_YYYY}${VERSION_MMDD}
 
 !define MY_ABI   "5"
Index: package/mingw-ncurses.spec
--- ncurses-6.1-20181125+/package/mingw-ncurses.spec	2018-11-25 11:25:14.000000000 +0000
+++ ncurses-6.1-20181201/package/mingw-ncurses.spec	2018-11-30 23:49:03.000000000 +0000
@@ -3,7 +3,7 @@
 Summary: shared libraries for terminal handling
 Name: mingw32-ncurses6
 Version: 6.1
-Release: 20181125
+Release: 20181201
 License: X11
 Group: Development/Libraries
 Source: ncurses-%{version}-%{release}.tgz
Index: package/ncurses.spec
--- ncurses-6.1-20181125+/package/ncurses.spec	2018-11-25 11:25:14.000000000 +0000
+++ ncurses-6.1-20181201/package/ncurses.spec	2018-11-30 23:49:03.000000000 +0000
@@ -1,7 +1,7 @@
 Summary: shared libraries for terminal handling
 Name: ncurses6
 Version: 6.1
-Release: 20181125
+Release: 20181201
 License: X11
 Group: Development/Libraries
 Source: ncurses-%{version}-%{release}.tgz
Index: package/ncursest.spec
--- ncurses-6.1-20181125+/package/ncursest.spec	2018-11-25 11:25:14.000000000 +0000
+++ ncurses-6.1-20181201/package/ncursest.spec	2018-11-30 23:49:03.000000000 +0000
@@ -1,7 +1,7 @@
 Summary: Curses library with POSIX thread support.
 Name: ncursest6
 Version: 6.1
-Release: 20181125
+Release: 20181201
 License: X11
 Group: Development/Libraries
 Source: ncurses-%{version}-%{release}.tgz
Index: test/aclocal.m4
Prereq:  1.160 
--- ncurses-6.1-20181125+/test/aclocal.m4	2018-08-18 20:39:24.000000000 +0000
+++ ncurses-6.1-20181201/test/aclocal.m4	2018-12-01 21:05:05.000000000 +0000
@@ -26,7 +26,7 @@
 dnl authorization.                                                           *
 dnl***************************************************************************
 dnl
-dnl $Id: aclocal.m4,v 1.160 2018/08/18 20:39:24 tom Exp $
+dnl $Id: aclocal.m4,v 1.161 2018/12/01 21:05:05 tom Exp $
 dnl
 dnl Author: Thomas E. Dickey
 dnl
@@ -3831,7 +3831,7 @@
 
 ])dnl
 dnl ---------------------------------------------------------------------------
-dnl CF_XOPEN_SOURCE version: 53 updated: 2018/06/16 18:58:58
+dnl CF_XOPEN_SOURCE version: 54 updated: 2018/11/07 07:43:44
 dnl ---------------
 dnl Try to get _XOPEN_SOURCE defined properly that we can use POSIX functions,
 dnl or adapt to the vendor's definitions to get equivalent functionality,
@@ -3861,7 +3861,7 @@
 	cf_xopen_source="-D_DARWIN_C_SOURCE"
 	cf_XOPEN_SOURCE=
 	;;
-(freebsd*|dragonfly*)
+(freebsd*|dragonfly*|midnightbsd*)
 	# 5.x headers associate
 	#	_XOPEN_SOURCE=600 with _POSIX_C_SOURCE=200112L
 	#	_XOPEN_SOURCE=500 with _POSIX_C_SOURCE=199506L
Index: test/configure
--- ncurses-6.1-20181125+/test/configure	2018-10-06 23:01:48.000000000 +0000
+++ ncurses-6.1-20181201/test/configure	2018-12-01 21:05:23.000000000 +0000
@@ -3408,7 +3408,7 @@
 	cf_xopen_source="-D_DARWIN_C_SOURCE"
 	cf_XOPEN_SOURCE=
 	;;
-(freebsd*|dragonfly*)
+(freebsd*|dragonfly*|midnightbsd*)
 	# 5.x headers associate
 	#	_XOPEN_SOURCE=600 with _POSIX_C_SOURCE=200112L
 	#	_XOPEN_SOURCE=500 with _POSIX_C_SOURCE=199506L
Index: test/ncurses.c
Prereq:  1.508 
--- ncurses-6.1-20181125+/test/ncurses.c	2018-09-22 21:21:43.000000000 +0000
+++ ncurses-6.1-20181201/test/ncurses.c	2018-12-02 01:11:05.000000000 +0000
@@ -40,7 +40,7 @@
    Author: Eric S. Raymond <esr@snark.thyrsus.com> 1993
            Thomas E. Dickey (beginning revision 1.27 in 1996).
 
-$Id: ncurses.c,v 1.508 2018/09/22 21:21:43 tom Exp $
+$Id: ncurses.c,v 1.510 2018/12/02 01:11:05 tom Exp $
 
 ***************************************************************************/
 
@@ -4367,7 +4367,10 @@
     void (*last_show_wacs) (int, attr_t, NCURSES_PAIRS_T) = 0;
     W_ATTR_TBL my_list[SIZEOF(w_attrs_to_test)];
     unsigned my_size = init_w_attr_list(my_list, term_attrs());
+    char at_page[5];
+    bool pending_code = FALSE;
 
+    at_page[0] = '\0';
     do {
 	switch (c) {
 	case CTRL('L'):
@@ -4399,15 +4402,39 @@
 	case 'u':
 	    ToggleAcs(last_show_wacs, show_utf8_chars);
 	    break;
+	case '@':
+	    pending_code = !pending_code;
+	    if (pending_code) {
+		sprintf(at_page, "%02x", digit);
+	    } else if (at_page[0] != '\0') {
+		sscanf(at_page, "%x", &digit);
+	    }
+	    break;
 	default:
-	    if (c < 256 && isdigit(c)) {
+	    if (pending_code && isxdigit(c)) {
+		size_t len = strlen(at_page);
+		if (len && at_page[0] == '0') {
+		    memmove(at_page, at_page + 1, len--);
+		}
+		if (len < sizeof(at_page) - 1) {
+		    at_page[len++] = (char) c;
+		    at_page[len] = '\0';
+		}
+	    } else if (pending_code
+		       && (c == '\b' || c == KEY_BACKSPACE || c == KEY_DC)) {
+		size_t len = strlen(at_page);
+		if (len)
+		    at_page[--len] = '\0';
+	    } else if (c < 256 && isdigit(c)) {
 		digit = (c - '0');
 		last_show_wacs = 0;
 	    } else if (c == '+') {
 		++digit;
+		sprintf(at_page, "%02x", digit);
 		last_show_wacs = 0;
 	    } else if (c == '-' && digit > 0) {
 		--digit;
+		sprintf(at_page, "%02x", digit);
 		last_show_wacs = 0;
 	    } else if (c == '>' && repeat < (COLS / 4)) {
 		++repeat;
@@ -4435,7 +4462,11 @@
 	}
 
 	MvPrintw(LINES - 4, 0,
-		 "Select: a/d/t WACS, w=all x=box, u UTF-8, ^L repaint");
+		 "Select: a/d/t WACS, w=%d/page, @",
+		 pagesize);
+	printw("%s",
+	       pending_code ? at_page : "page");
+	addstr(", x=box, u UTF-8, ^L repaint");
 	MvPrintw(LINES - 3, 2,
 		 "0-9,+/- non-ASCII, </> repeat, _ space, ESC=quit");
 	if (UseColors) {
